
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

		-- Don't forget to include your character's custom assets!
        Asset( "ANIM", "anim/isc.zip" ),
}
local prefabs = {}

local start_inv = 
{
"blowdart_pipe",
"bombs",
}

local function sanityfn(inst)
	local x,y,z = inst.Transform:GetWorldPosition()	
	local delta = 0
	local max_rad = 10
	local ents = TheSim:FindEntities(x,y,z, max_rad, {"fire"})
    for k,v in pairs(ents) do 
    	if v.components.burnable and v.components.burnable.burning then
    		local sz = TUNING.SANITYAURA_TINY
    		local rad = v.components.burnable:GetLargestLightRadius() or 1
    		sz = sz * ( math.min(max_rad, rad) / max_rad )
			local distsq = inst:GetDistanceSqToInst(v)
			delta = delta + sz/math.max(1, distsq)
    	end
    end
    
    return delta
end

local fn = function(inst)
	
	-- choose which sounds this character will play
	inst.soundsname = "wilson"

	-- a minimap icon must be specified
	inst.MiniMapEntity:SetIcon( "wilson.png" )

	-- todo: Add an example special power here.
	
	inst.components.health:SetMaxHealth(TUNING.WILSON_HEALTH * 1 )
	inst.components.hunger:SetMax(TUNING.WILSON_HUNGER * 1 )
	inst.components.combat.damagemultiplier = 1
	inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE)
	inst.components.sanity:SetMax(TUNING.WILSON_SANITY* 1.5)
	inst.components.sanity.custom_rate_fn = sanityfn
	
	inst.components.eater.stale_hunger = TUNING.WILSON_STALE_FOOD_HUNGER
    inst.components.eater.stale_health = TUNING.WILSON_STALE_FOOD_HEALTH
    inst.components.eater.spoiled_hunger = TUNING.WILSON_SPOILED_FOOD_HUNGER
    inst.components.eater.spoiled_health = TUNING.WILSON_SPOILED_FOOD_HEALTH
	
end


-- strings! Any "isc" below would have to be replaced by the prefab name of your character.

-- First up, the character select screen lines 
-- note: these are lower-case character name
STRINGS.CHARACTER_TITLES.isc = "Isaac"
STRINGS.CHARACTER_NAMES.isc = "isc"
STRINGS.CHARACTER_DESCRIPTIONS.isc = "*Any special abilities."
STRINGS.CHARACTER_QUOTES.isc = "\"Hero of game The Binding of Isaac.\""

-- You can also add any kind of custom dialogue that you would like. Don't forget to make
-- categores that don't exist yet using = {}
-- note: these are UPPER-CASE charcacter name
STRINGS.CHARACTERS.isc = {}
STRINGS.CHARACTERS.isc.DESCRIBE = {}
STRINGS.CHARACTERS.isc.DESCRIBE.EVERGREEN = "Its important we protect our resources."



return MakePlayerCharacter("isc", prefabs, assets, fn, start_inv)
